// Shared Array
// Make a user-specified number of increments to random elements of an
// array of user-specified size

#include <magic_services.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void print_array(int* array, int length) {
  int i;

  printf("[");
  for (i = 0; i < length - 1; i++) {
    printf("%d, ", array[i]);
  }
  printf("%d]\n", array[length - 1]);
}

void verify(int* array, int length, int num_incr) {
  int i; // loop counter
  int sum = 0;

  for (i = 0; i < length; i++) {
    sum += array[i];
  }

  if (sum == num_incr) {
    printf("CORRECT!\n");
  } else {
    printf("ERROR!");
    printf("Expected: %d Counted: %d\n", num_incr, sum);
  }
}

int main(int argc, char** argv) {
  // variables
  int num_elems; // the number of elements in the shared array
  int num_incr; // the number of increments to make to the shared array
  int i; // loop counter
  //int index; // the index to increment
  int* sa; // shared array
  float RAND_FACTOR; // rand multiplier to get an index in the appropriate range

  // parse arguments
  if (argc < 3) {
    printf("**************************************************\n");
    printf("* USAGE:                                         *\n");
    printf("* sa-seq <num_elems> <num_incr>                  *\n");
    printf("* <num_elems> - the size of the array            *\n");
    printf("* <num_incr>  - the number of increments to make *\n");
    printf("**************************************************\n");
    exit(-1);
  } else {
    num_elems = atoi(argv[1]);
    num_incr = atoi(argv[2]);

    printf("num_elems: %d\n", num_elems);
    printf("num_incr: %d\n", num_incr);
  }

  // create and initialize shared array
  sa = (int*) malloc(num_elems * sizeof(int));
  for (i = 0; i < num_elems; i++) {
    sa[i] = 0;
  }
  //printf("*** INIT ***\n");
  //print_array(sa, num_elems);

  // perform random increments
  srand(time(0));

  RUBY_MAGIC_CALL(Do_Breakpoint, 0);

  RAND_FACTOR = (float) (num_elems - 1) / RAND_MAX;
  //printf("RAND_FACTOR=%f\n", RAND_FACTOR);
  for (i = 0; i < num_incr; i++) {
    /*
    index = (int) (rand() * RAND_FACTOR);
    if (index < 0 || index > num_elems - 1) {
      printf("BAD INDEX: idx=%d\n", index);
    } else {
      sa[index]++;
    }
    */
    sa[(int) (rand() * RAND_FACTOR)]++;
  }
  //printf("*** FINAL ***\n");
  //print_array(sa, num_elems);
  verify(sa, num_elems, num_incr);

  RUBY_MAGIC_CALL(Do_Breakpoint, 0);

  return 0;
}
