#ifndef TRANSACTION_H_
#define TRANSACTION_H_

/* -- Make sure that the two definitions below are consistent, e.g., %l0 == %r16 */
#define   RUBY_MAGIC_REGISTER_NAME  "l0"
#define   Ruby_Magic_Register_Number  16

#define NEW_RUBY_MAGIC_CALL( service )                      \
    __asm__ __volatile__                                    \
    ( "sethi %1, %%g0  !magic service\n\t"                  \
          : /* no outputs */                                \
      : "r" (0), "i" ((service)<<16)                        \
          : "l0" /* clobber register */                     \
        );                                                        

#define BEGIN_TRANSACTION(id) NEW_RUBY_MAGIC_CALL((id + 20))
#define COMMIT_TRANSACTION(id) NEW_RUBY_MAGIC_CALL((id + 40))
#define ABORT_TRANSACTION NEW_RUBY_MAGIC_CALL(19)
#define ABORT_DONE NEW_RUBY_MAGIC_CALL(18)
#define ABORT_HANDLER NEW_RUBY_MAGIC_CALL(17)

extern int begin_transaction(int id);

extern int end_transaction(int id);
		
#endif /* TRANSACTION_H_ */
